#!/bin/bash

# Disjkstra's shortest path in directed graph
#input : first line - A B , A --pt to start from  , B - num of pts
#other lines - X Y T , Arc from X to Y , length T
#last line - 0 0 0

#puts in ARR  VAL on position K
function putval()
{
   let mm=K-1;
   prev=`echo $ARR |cut -d ' ' -f -$mm` 
   if [ $mm -eq 0 ] ; then
     prev=""
   fi
   let mm=K+1;
   aft=`echo $ARR |cut -d ' ' -f $mm-`   
   ARR="$prev $VAL $aft"
}
arcstr=""
read beg num
x=1;y=1;t=1
numv=0;
max=100;
while  [ $x -ne 0 ] || [ $y -ne 0 ] ||  [ $t -ne 0 ] ; do
   read x y t
   arcstr="$arcstr $x $y $t"
   let numv=$numv+1
   let max=$max+$t
done

let i=0;
while [ $i -lt $num ] ; do
   ptstr="$ptstr $max"
   let i=$i+1
done

ARR=$ptstr;K=$beg;VAL=0;putval;ptstr="$ARR"
queue="$beg "

# main loop
while ! [ -z "$queue" ] ; do
   i=`echo "$queue" |cut -d ' ' -f 1` 
   let x=0;
   cway=`echo $ptstr |cut -d ' ' -f $i `
   while [ $x -lt $numv ] ; do
# find all adjacent verticies
     let pos=$x*3+1 
     vert=`echo $arcstr |cut -d ' ' -f $pos`
     if [ $vert -eq $i ] ; then
       let pos0=$pos+1; nextvert=`echo $arcstr |cut -d ' ' -f $pos0`
       let pos0=$pos0+1; way_nxt=`echo $arcstr |cut -d ' ' -f $pos0`
       let pos_way=$cway+$way_nxt 
       curway=`echo $ptstr |cut -d ' ' -f $nextvert`
       if [ $curway -gt $pos_way ] ; then
# we have a winner! :)
         queue="$queue$nextvert "
         ARR="$ptstr";K=$nextvert;VAL=$pos_way;putval;ptstr="$ARR"
       fi
     fi
     let x=$x+1
   done
   queue=`echo "$queue"|cut -d ' ' -f 2-`
done
echo $ptstr
